#! /usr/bin/env python
# -*- coding:Shift_JIS -*-
from gimpfu import *

def isSelected(NorImg):
  b = False
  b, x1, y1, x2, y2 = pdb.gimp_selection_bounds(NorImg)
  return b

def python_SelectBubble(img, drawable, outer_color, inner_color, blur, isRelease, isLayer):
  if not isSelected(img):
    pdb.gimp_message('There is no selection!')
    return
  # + O obNAbv
  img.undo_group_start()
  old_layer = img.active_layer
  old_color=gimp.get_foreground()
  selection = pdb.gimp_selection_save(img)	# I͈͂ۑ
  
  # + C[ǉ
  layer = old_layer ;
  if (isLayer) :
    # RGB_IMAGE: RGBA_IMAGE:
    layer = gimp.Layer(img, "Speech Bubble", drawable.width, drawable.height, RGBA_IMAGE, 100, NORMAL_MODE)
    img.add_layer(layer, 0)			#
    pdb.gimp_image_set_active_layer(img,layer)	# ǉC[ANeBuɂ
    pdb.gimp_selection_none(img)		# I
    pdb.gimp_selection_load(selection)		# I𕜋A
  # + 
  pdb.gimp_selection_feather(img, blur)		# I͈͂ڂ
  pdb.gimp_context_set_foreground(outer_color)	# OF
  pdb.gimp_edit_fill(layer, FOREGROUND_FILL)	#
  pdb.gimp_selection_none(img)			# I
  pdb.gimp_selection_load(selection)		# I𕜋A
  #pdb.gimp_edit_clear(layer)			# ڂȎI͈͓폜
  pdb.gimp_context_set_foreground(inner_color)	# F
  pdb.gimp_edit_fill(layer, FOREGROUND_FILL)	#
  pdb.gimp_image_remove_channel(img,selection)	# ۑI͈͂폜
  
  if isRelease:
    pdb.gimp_selection_none(img)
  
  # + ㏈ A
  pdb.gimp_context_set_foreground(old_color)
  pdb.gimp_image_set_active_layer(img,old_layer)
  img.undo_group_end()
  return

register(
        "python_fu_SelectBubble",
        "Select Bubble",
        "Select -> Speech Bubble !",
        "Keina<keines.2007@gmail.com>",
        "k.keina",
        "2008.11.22(Sat) 15:08",
        "<Image>/Filters/Misc/Select Bubble...",
        "RGB*, GRAY*",
        [
            (PF_COLOR	,"outer_color"	,"Outer Color:"		, (0, 0, 0)),
            (PF_COLOR	,"inner_color"	,"Inner Color:"		, (255, 255, 255)),
            (PF_SPINNER	,"blur"		,"Blur:"		, 5,(0,100,1)),
            (PF_TOGGLE	,"isRelease"	,"Select Release:"	, TRUE),
            (PF_TOGGLE	,"isLayer"	,"New Layer:"		, TRUE)
        ],
        [],
        python_SelectBubble)

main()
